window.onload = function() {
  // Sample dictionary containing strings and relative file paths
  var data = {
    'Index': 'index.html',
    'Split-phase Grid': 'split-phase_grid.html',
    'PE Loads': 'pe_loads.html',
    'BESS (avg)': 'bess_(avg).html',
    'Thermal Magnetic Breaker': 'thermal_magnetic_breaker.html',
    'Wind Turbine': 'wind_turbine.html',
    'ZIP Loads': 'zip_loads.html',
    'PV System (avg)': 'pv_system_(avg).html',
    'Single-phase Genset': 'single-phase_genset.html',
    'PV Array with Microinverters': 'pv_array_with_microinverters.html',
  };

  // Create the new div
  var newDiv = document.createElement('div');
  newDiv.id = 'left-section';

  // Create the unordered list
  var newList = document.createElement('ul');

  // Iterate over the data and create list items with hyperlinks
  for (var key in data) {
    if (data.hasOwnProperty(key)) {
      var listItem = document.createElement('li');
      var link = document.createElement('a');
      link.href = data[key]; // Relative file path
      link.textContent = key; // Display text
      listItem.appendChild(link);
      newList.appendChild(listItem);
    }
  }

  // Append the unordered list to the new div
  newDiv.appendChild(newList);

  // Get the toc div and the content div
  var tocDiv = document.getElementById('toc');
  var contentDiv = document.getElementById('content');

  // Insert the new div after the toc div and before the content div
  tocDiv.parentNode.insertBefore(newDiv, tocDiv.nextSibling);
};
