def mask_dialog_dynamics(mdl, container_handle, caller_prop_handle=None):

    # Property Registration
    brk_inp_prop = mdl.prop(container_handle, "brk_inp")
    man_coeff_prop = mdl.prop(container_handle, "man_coeff")
    op_mode_prop = mdl.prop(container_handle, "op_mode")


    new_value = None
    if caller_prop_handle:
        new_value = mdl.get_property_disp_value(caller_prop_handle)

    # ------------------------------------------------------------------------------------------------------------------
    #  External Breaker
    # ------------------------------------------------------------------------------------------------------------------
    if caller_prop_handle == brk_inp_prop:

        if not new_value:
            mdl.enable_property(mdl.prop(container_handle, "brk_delay"))
        else:
            mdl.disable_property(mdl.prop(container_handle, "brk_delay"))

    # ------------------------------------------------------------------------------------------------------------------
    #  Manual Control settings
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == man_coeff_prop:
        if not new_value:
            mdl.disable_property(mdl.prop(container_handle, "Kpp_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kip_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kpq_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kiq_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kpv_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kiv_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kpw_m"))
            mdl.disable_property(mdl.prop(container_handle, "Kiw_m"))
            mdl.disable_property(mdl.prop(container_handle, "ctrl_def"))
        else:
            mdl.enable_property(mdl.prop(container_handle, "Kpp_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kip_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kpq_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kiq_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kpv_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kiv_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kpw_m"))
            mdl.enable_property(mdl.prop(container_handle, "Kiw_m"))
            mdl.enable_property(mdl.prop(container_handle, "ctrl_def"))

    # ------------------------------------------------------------------------------------------------------------------
    #  Operation mode settings
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == op_mode_prop:
        if new_value == "External Input":
            mdl.set_property_disp_value(mdl.prop(container_handle, "P_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "Q_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "V_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "F_ref_mode"), "External Input")
            mdl.show_property(mdl.prop(container_handle, "P_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "Q_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "V_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "F_ref_mode"))
        elif new_value == "Grid forming":
            mdl.set_property_disp_value(mdl.prop(container_handle, "P_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "Q_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "V_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "F_ref_mode"), "Nominal")
            mdl.hide_property(mdl.prop(container_handle, "P_ref_mode"))
            mdl.hide_property(mdl.prop(container_handle, "Q_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "V_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "F_ref_mode"))
        elif new_value == "PQ":
            mdl.set_property_disp_value(mdl.prop(container_handle, "P_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "Q_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "V_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "F_ref_mode"), "Nominal")
            mdl.show_property(mdl.prop(container_handle, "P_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "Q_ref_mode"))
            mdl.hide_property(mdl.prop(container_handle, "V_ref_mode"))
            mdl.hide_property(mdl.prop(container_handle, "F_ref_mode"))
        elif new_value == "PV":
            mdl.set_property_disp_value(mdl.prop(container_handle, "P_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "Q_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "V_ref_mode"), "Nominal")
            mdl.set_property_disp_value(mdl.prop(container_handle, "F_ref_mode"), "Nominal")
            mdl.show_property(mdl.prop(container_handle, "P_ref_mode"))
            mdl.hide_property(mdl.prop(container_handle, "Q_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "V_ref_mode"))
            mdl.hide_property(mdl.prop(container_handle, "F_ref_mode"))
        else:
            mdl.set_property_disp_value(mdl.prop(container_handle, "P_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "Q_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "V_ref_mode"), "External Input")
            mdl.set_property_disp_value(mdl.prop(container_handle, "F_ref_mode"), "External Input")
            mdl.show_property(mdl.prop(container_handle, "P_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "Q_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "V_ref_mode"))
            mdl.show_property(mdl.prop(container_handle, "F_ref_mode"))


def mask_control_signal_dynamics(mdl, container_handle, caller_prop_handle=None, init=False):
    """

    :param mdl:
    :param container_handle:
    :param caller_prop_handle:
    :param init:
    :return:

    """
    # Property Registration
    brk_inp_prop = mdl.prop(container_handle, "brk_inp")
    op_mode_prop = mdl.prop(container_handle, "op_mode")
    P_ref_mode_prop = mdl.prop(container_handle, "P_ref_mode")
    Q_ref_mode_prop = mdl.prop(container_handle, "Q_ref_mode")
    V_ref_mode_prop = mdl.prop(container_handle, "V_ref_mode")
    F_ref_mode_prop = mdl.prop(container_handle, "F_ref_mode")

    new_value = None

    if caller_prop_handle:
        new_value = mdl.get_property_value(caller_prop_handle)

    # ------------------------------------------------------------------------------------------------------------------
    #  External breaker setup
    # ------------------------------------------------------------------------------------------------------------------
    if caller_prop_handle == brk_inp_prop:
        comp_handle = mdl.get_parent(container_handle)
        ext_breaker = mdl.get_item("brk", parent=comp_handle, item_type="port")
        tag5 = mdl.get_item("Goto5", parent=comp_handle, item_type="tag")
        int_breaker = mdl.get_item("zero_flag1", parent=comp_handle, item_type="component")

        if not new_value:
            if ext_breaker:
                mdl.delete_item(ext_breaker)
            if not int_breaker:
                int_breaker = mdl.create_component("core/Constant",
                                                   name="zero_flag1",
                                                   parent=comp_handle,
                                                   position=[6896, 7888])
                mdl.set_property_value(mdl.prop(int_breaker, "value"), 0)
                mdl.set_property_value(mdl.prop(int_breaker, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_breaker, "out"), tag5):
                mdl.create_connection(mdl.term(int_breaker, "out"), tag5)
        else:
            if int_breaker:
                mdl.delete_item(int_breaker)
            if not ext_breaker:
                ext_breaker = mdl.create_port(name="brk",
                                              parent=comp_handle,
                                              position=(6896, 7888),
                                              terminal_position=(-16.0, -64.0),
                                              kind="sp",
                                              direction="in", )
            if not mdl.find_connections(ext_breaker, tag5):
                mdl.create_connection(ext_breaker, tag5)

    # ------------------------------------------------------------------------------------------------------------------
    #  Operation mode settings
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == op_mode_prop:

        comp_handle = mdl.get_parent(container_handle)
        ext_mode = mdl.get_item("mode", parent=comp_handle, item_type="port")
        tag4 = mdl.get_item("Goto4", parent=comp_handle, item_type="tag")
        int_mode = mdl.get_item("zero_flag2", parent=comp_handle, item_type="component")

        if new_value == "Grid forming":
            mdl.set_property_value(mdl.prop(container_handle, "P_ref_mode"), "Nominal")
            mdl.set_property_value(mdl.prop(container_handle, "Q_ref_mode"), "Nominal")
        elif new_value == "PQ":
            mdl.set_property_value(mdl.prop(container_handle, "V_ref_mode"), "Nominal")
            mdl.set_property_value(mdl.prop(container_handle, "F_ref_mode"), "Nominal")
        elif new_value == "PV":
            mdl.set_property_value(mdl.prop(container_handle, "Q_ref_mode"), "Nominal")
            mdl.set_property_value(mdl.prop(container_handle, "F_ref_mode"), "Nominal")

        if new_value == "External Input":
            if int_mode:
                mdl.delete_item(int_mode)
            if not ext_mode:
                ext_mode = mdl.create_port(name="mode",
                                           parent=comp_handle,
                                           position=(6896, 7807),
                                           terminal_position=(16.0, -64.0),
                                           kind="sp",
                                           direction="in", )
            if not mdl.find_connections(ext_mode, tag4):
                mdl.create_connection(ext_mode, tag4)
        else:
            if ext_mode:
                mdl.delete_item(ext_mode)
            if not int_mode:
                int_mode = mdl.create_component("core/Constant",
                                                name="zero_flag2",
                                                parent=comp_handle,
                                                position=[6896, 7807])
                mdl.set_property_value(mdl.prop(int_mode, "value"), 0)
                mdl.set_property_value(mdl.prop(int_mode, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_mode, "out"), tag4):
                mdl.create_connection(mdl.term(int_mode, "out"), tag4)

    # ------------------------------------------------------------------------------------------------------------------
    #  P Command
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == P_ref_mode_prop:

        comp_handle = mdl.get_parent(container_handle)
        ext_P = mdl.get_item("P*", parent=comp_handle, item_type="port")
        gen_ctrl = mdl.get_item("genset_control", parent=comp_handle, item_type="component")
        int_P = mdl.get_item("P_nominal", parent=comp_handle, item_type="component")

        if new_value == "External Input":
            if int_P:
                mdl.delete_item(int_P)
            if not ext_P:
                ext_P = mdl.create_port(name="P*",
                                        parent=comp_handle,
                                        position=(6184, 7936),
                                        terminal_position=(-64.0, -48.0),
                                        kind="sp",
                                        direction="in", )
            if not mdl.find_connections(ext_P, mdl.term(gen_ctrl, "P_ref")):
                mdl.create_connection(ext_P, mdl.term(gen_ctrl, "P_ref"))
        else:
            if ext_P:
                mdl.delete_item(ext_P)
            if not int_P:
                int_P = mdl.create_component("core/Constant",
                                             name="P_nominal",
                                             parent=comp_handle,
                                             position=[6184, 7936])
                mdl.set_property_value(mdl.prop(int_P, "value"), "Pnom")
                mdl.set_property_value(mdl.prop(int_P, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_P, "out"), mdl.term(gen_ctrl, "P_ref")):
                mdl.create_connection(mdl.term(int_P, "out"), mdl.term(gen_ctrl, "P_ref"))

    # ------------------------------------------------------------------------------------------------------------------
    #  Q Command
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == Q_ref_mode_prop:
        comp_handle = mdl.get_parent(container_handle)
        ext_Q = mdl.get_item("Q*", parent=comp_handle, item_type="port")
        gen_ctrl = mdl.get_item("genset_control", parent=comp_handle, item_type="component")
        int_Q = mdl.get_item("Q_nominal", parent=comp_handle, item_type="component")

        if new_value == "External Input":
            if int_Q:
                mdl.delete_item(int_Q)
            if not ext_Q:
                ext_Q = mdl.create_port(name="Q*",
                                        parent=comp_handle,
                                        position=(6184, 7983),
                                        terminal_position=(-64.0, -16.0),
                                        kind="sp",
                                        direction="in", )
            if not mdl.find_connections(ext_Q, mdl.term(gen_ctrl, "Q_ref")):
                mdl.create_connection(ext_Q, mdl.term(gen_ctrl, "Q_ref"))
        else:
            if ext_Q:
                mdl.delete_item(ext_Q)
            if not int_Q:
                int_Q = mdl.create_component("core/Constant",
                                             name="Q_nominal",
                                             parent=comp_handle,
                                             position=[6184, 7983])
                mdl.set_property_value(mdl.prop(int_Q, "value"), "Qnom")
                mdl.set_property_value(mdl.prop(int_Q, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_Q, "out"), mdl.term(gen_ctrl, "Q_ref")):
                mdl.create_connection(mdl.term(int_Q, "out"), mdl.term(gen_ctrl, "Q_ref"))

    # ------------------------------------------------------------------------------------------------------------------
    #  V Command
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == V_ref_mode_prop:
        comp_handle = mdl.get_parent(container_handle)
        ext_V = mdl.get_item("V*", parent=comp_handle, item_type="port")
        gen_ctrl = mdl.get_item("genset_control", parent=comp_handle, item_type="component")
        int_V = mdl.get_item("V_nominal", parent=comp_handle, item_type="component")

        if new_value == "External Input":
            if int_V:
                mdl.delete_item(int_V)
            if not ext_V:
                ext_V = mdl.create_port(name="V*",
                                        parent=comp_handle,
                                        position=(6184, 8030),
                                        terminal_position=(-64.0, 16.0),
                                        kind="sp",
                                        direction="in", )
            if not mdl.find_connections(ext_V, mdl.term(gen_ctrl, "V_ref")):
                mdl.create_connection(ext_V, mdl.term(gen_ctrl, "V_ref"))
        else:
            if ext_V:
                mdl.delete_item(ext_V)
            if not int_V:
                int_V = mdl.create_component("core/Constant",
                                             name="V_nominal",
                                             parent=comp_handle,
                                             position=[6184, 8030])
                mdl.set_property_value(mdl.prop(int_V, "value"), "Vnom")
                mdl.set_property_value(mdl.prop(int_V, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_V, "out"), mdl.term(gen_ctrl, "V_ref")):
                mdl.create_connection(mdl.term(int_V, "out"), mdl.term(gen_ctrl, "V_ref"))

    # ------------------------------------------------------------------------------------------------------------------
    #  F Command
    # ------------------------------------------------------------------------------------------------------------------
    elif caller_prop_handle == F_ref_mode_prop:
        comp_handle = mdl.get_parent(container_handle)
        ext_F = mdl.get_item("F*", parent=comp_handle, item_type="port")
        w_gain = mdl.get_item("Gain3", parent=comp_handle, item_type="component")
        int_F = mdl.get_item("F_nominal", parent=comp_handle, item_type="component")

        if new_value == "External Input":
            if int_F:
                mdl.delete_item(int_F)
            if not ext_F:
                ext_F = mdl.create_port(name="F*",
                                        parent=comp_handle,
                                        position=(6096, 8080),
                                        terminal_position=(-64.0, 48.0),
                                        kind="sp",
                                        direction="in", )
            if not mdl.find_connections(ext_F, mdl.term(w_gain, "in")):
                mdl.create_connection(ext_F, mdl.term(w_gain, "in"))
        else:
            if ext_F:
                mdl.delete_item(ext_F)
            if not int_F:
                int_F = mdl.create_component("core/Constant",
                                             name="F_nominal",
                                             parent=comp_handle,
                                             position=[6096, 8080])
                mdl.set_property_value(mdl.prop(int_F, "value"), "Fnom")
                mdl.set_property_value(mdl.prop(int_F, "execution_rate"), "Ts")
            if not mdl.find_connections(mdl.term(int_F, "out"), mdl.term(w_gain, "in")):
                mdl.create_connection(mdl.term(int_F, "out"), mdl.term(w_gain, "in"))


def mask_estimate_function(mdl, container_handle, caller_prop_handle=None):

    # Property Registration
    ctrl_def_prop = mdl.prop(container_handle, "ctrl_def")


    # ------------------------------------------------------------------------------------------------------------------
    #  Estimate
    # ------------------------------------------------------------------------------------------------------------------
    if caller_prop_handle == ctrl_def_prop:

        import numpy
        import math

        S = float(mdl.get_property_disp_value(mdl.prop(container_handle, "Snom")))
        Freq = float(mdl.get_property_disp_value(mdl.prop(container_handle, "Fnom")))
        Power = float(mdl.get_property_disp_value(mdl.prop(container_handle, "Pnom")))
        RPM = float(mdl.get_property_disp_value(mdl.prop(container_handle, "Nnom")))
        Vll = float(mdl.get_property_disp_value(mdl.prop(container_handle, "Vnom")))

        PP = Freq * 60 / RPM
        ws = 2 * numpy.pi * Freq
        Tnm = 1.2 * Power / (ws / PP)
        Vph = numpy.sqrt(2) * Vll

        Kpp_temp = 0.0377 / (ws / PP)
        Kip_temp = 0.377e3 / (ws / PP)
        Kpq_temp = 0.0078 / (Vph)
        Kiq_temp = 15.56 / (Vph)

        Kpp = round(Kpp_temp, -(int("{:e}".format(Kpp_temp).split('e')[1]) - 2))
        Kip = round(Kip_temp, -(int("{:e}".format(Kip_temp).split('e')[1]) - 2))
        Kpq = round(Kpq_temp, -(int("{:e}".format(Kpq_temp).split('e')[1]) - 2))
        Kiq = round(Kiq_temp, -(int("{:e}".format(Kiq_temp).split('e')[1]) - 2))
        Kpv = 0.02
        Kiv = 3
        Kpw = 10
        Kiw = 20

        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kpp_m'), Kpp)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kip_m'), Kip)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kpq_m'), Kpq)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kiq_m'), Kiq)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kpv_m'), Kpv)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kiv_m'), Kiv)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kpw_m'), Kpw)
        mdl.set_property_disp_value(mdl.prop(container_handle, 'Kiw_m'), Kiw)


def define_icon(mdl, container_handle):
    """
    Defines the component icon based on its type

    :param mdl: Schematic API
    :param container_handle: Component Handle
    :return: no return
    """
    mdl.set_component_icon_image(container_handle, "./residential_comp_images/res_gen.svg", rotate="no_rotate")
    mdl.set_color(container_handle, "blue")
    #mdl.disp_component_icon_text(container_handle, "avg", size=10, relpos_x=0.8, relpos_y=0.87)

