
def wt_type_edit(mdl, mask_handle, wt_type):
    comp_handle = mdl.get_parent(mask_handle)
    #mdl.set_property_value(mdl.prop(mask_handle, "WT"), new_value)
    wt_type_prop = mdl.prop(mask_handle, "wt_type")
    cp_curve_prop = mdl.prop(mask_handle, "cp_curve")

    wt = mdl.get_item("Wind Turbine", parent=comp_handle, item_type="component")

    if wt_type == "Custom":
        mdl.set_property_combo_values(cp_curve_prop, ["Heier", "Slootweg", "External"])
        mdl.set_property_disp_value(cp_curve_prop, "Heier")
        mdl.enable_property(cp_curve_prop)

        mdl.enable_property(mdl.prop(mask_handle, "usr_pwr"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_dia"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_Jr"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_gen_torque"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_rot_spd_rated"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_gearbox"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_w_cutin"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_w_rated"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_w_cutout"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_rot_spd_start"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_tsr_gain"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_bld_wb"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_bld_zeta"))
        mdl.enable_property(mdl.prop(mask_handle, "usr_bld_rate_lim"))

        mdl.enable_property(mdl.prop(wt, "usr_pwr"))
        mdl.enable_property(mdl.prop(wt, "usr_dia"))
        mdl.enable_property(mdl.prop(wt, "usr_Jr"))
        mdl.enable_property(mdl.prop(wt, "usr_gen_torque"))
        mdl.enable_property(mdl.prop(wt, "usr_rot_spd_rated"))
        mdl.enable_property(mdl.prop(wt, "usr_gearbox"))
        mdl.enable_property(mdl.prop(wt, "usr_w_cutin"))
        mdl.enable_property(mdl.prop(wt, "usr_w_rated"))
        mdl.enable_property(mdl.prop(wt, "usr_w_cutout"))
        mdl.enable_property(mdl.prop(wt, "usr_rot_spd_start"))
        mdl.enable_property(mdl.prop(wt, "usr_tsr_gain"))
        mdl.enable_property(mdl.prop(wt, "usr_bld_wb"))
        mdl.enable_property(mdl.prop(wt, "usr_bld_zeta"))
        mdl.enable_property(mdl.prop(wt, "usr_bld_rate_lim"))

    else:
        #Disable the Custom input fields
        mdl.disable_property(mdl.prop(mask_handle, "usr_pwr"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_dia"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_Jr"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_gen_torque"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_rot_spd_rated"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_gearbox"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_w_cutin"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_w_rated"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_w_cutout"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_rot_spd_start"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_tsr_gain"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_bld_wb"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_bld_zeta"))
        mdl.disable_property(mdl.prop(mask_handle, "usr_bld_rate_lim"))

        # Disable custom fields for the Wind Turbine component
        mdl.disable_property(mdl.prop(wt, "usr_pwr"))
        mdl.disable_property(mdl.prop(wt, "usr_dia"))
        mdl.disable_property(mdl.prop(wt, "usr_Jr"))
        mdl.disable_property(mdl.prop(wt, "usr_gen_torque"))
        mdl.disable_property(mdl.prop(wt, "usr_rot_spd_rated"))
        mdl.disable_property(mdl.prop(wt, "usr_gearbox"))
        mdl.disable_property(mdl.prop(wt, "usr_w_cutin"))
        mdl.disable_property(mdl.prop(wt, "usr_w_rated"))
        mdl.disable_property(mdl.prop(wt, "usr_w_cutout"))
        mdl.disable_property(mdl.prop(wt, "usr_rot_spd_start"))
        mdl.disable_property(mdl.prop(wt, "usr_tsr_gain"))
        mdl.disable_property(mdl.prop(wt, "usr_bld_wb"))
        mdl.disable_property(mdl.prop(wt, "usr_bld_zeta"))
        mdl.disable_property(mdl.prop(wt, "usr_bld_rate_lim"))

        # Use an internal Cp(beta, lambda) table to the 5.2 and 8.9 kW wt types
        if wt_type == "5.2 kW" or wt_type == "8.9 kW":
            mdl.set_property_combo_values(cp_curve_prop, ["Heier", "Slootweg", "External", "Internal Table"])
            mdl.set_property_disp_value(cp_curve_prop, "Internal Table")
            mdl.disable_property(cp_curve_prop)

    mdl.set_property_value(mdl.prop(wt, "wt_type"), wt_type)

    mdl.set_property_value(mdl.prop(wt, "cp_curve"), "cp_curve")
    mdl.set_property_value(mdl.prop(wt, "rho"), "rho")

# This function manages the Cp(β, λ) Extern input port.
# This port is deleted when unused or it is created when needed.
def cp_external_port_dyn(mdl, mask_handle):
    comp_handle = mdl.get_parent(mask_handle)
    cp_in_port = mdl.get_item("Cp(β, λ)", parent=comp_handle, item_type="port")
    wt_type_prop = mdl.prop(mask_handle, "wt_type")
    cp_combo_prop = mdl.prop(mask_handle, "cp_curve")
    cp_combo = mdl.get_property_value(cp_combo_prop)
    wt_type = mdl.get_property_value(wt_type_prop)
    wt_comp = mdl.get_item("Wind Turbine", parent=comp_handle, item_type="component")
    const_cp_unused = mdl.get_item("ConstCp", parent=comp_handle, item_type="component")

    if wt_type == "5.2 kW" or wt_type == "8.9 kW":
        if cp_in_port:
            mdl.delete_item(cp_in_port) #Delete the Cp() external input

            # Put a constant into the unused Wind Turbine internal component Cp() input
            if not const_cp_unused:
                const_cp_unused = mdl.create_component(
                    type_name="core/Constant",
                    parent=comp_handle,
                    name="ConstCp",
                    flip="flip_none",
                    position=(6384, 7984),
                    hide_name=False
                )
                mdl.set_property_value(mdl.prop(const_cp_unused, "value"), 0.0)
                mdl.create_connection(mdl.term(const_cp_unused, "out"),
                                      mdl.term(wt_comp, "Cp(β, λ) Extern"), name="Connection4859")

    elif wt_type == "Custom" and cp_combo != "External":
        if cp_in_port:
            mdl.delete_item(cp_in_port)

            # Put a constant into the unused Wind Turbine internal component Cp() input
            if not const_cp_unused:
                const_cp_unused = mdl.create_component(
                    type_name="core/Constant",
                    parent=comp_handle,
                    name="ConstCp",
                    flip="flip_none",
                    position=(6384, 7984),
                    hide_name=False
                )
                mdl.set_property_value(mdl.prop(const_cp_unused, "value"), 0.0)
                mdl.create_connection(mdl.term(const_cp_unused, "out"),
                                      mdl.term(wt_comp, "Cp(β, λ) Extern"), name="Connection4859")

    else:
        if const_cp_unused:
            mdl.delete_item(const_cp_unused)
        if not cp_in_port:
            cp_in_port = mdl.create_port(
                name="Cp(β, λ)",
                kind="sp",
                direction="in",
                parent=comp_handle,
                rotation='up',
                position=(6384, 7984),
                terminal_position=(16.0, -64.0)
            )

            mdl.create_connection(cp_in_port, mdl.term(wt_comp, "Cp(β, λ) Extern"), name="Connection4859")



def define_icon(mdl, container_handle):
    """
    Defines the component icon based on its type

    :param mdl: Schematic API
    :param container_handle: Component Handle
    :return: no return
    """
    mdl.set_component_icon_image(container_handle, "./residential_comp_images/res_wind.svg", rotate="no_rotate")
    #mdl.set_color(container_handle, "blue")
    #mdl.disp_component_icon_text(container_handle, size=10, relpos_x=0.8, relpos_y=0.87)

	